using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Security;
using System.Data.SqlClient;
using Microsoft.Win32;
using System.Text;
using System.Security.Cryptography;
using System.Configuration;

namespace Inject
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm2 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.CheckBox Persistent;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.TextBox Password;
		protected System.Web.UI.WebControls.Label Output;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator1;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator2;
		protected System.Web.UI.WebControls.TextBox UserName;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			if (IsValid) {
				if (Authenticate (UserName.Text, Password.Text))
					Output.Text = "Welcome, " + UserName.Text;
				else
					Output.Text = "Invalid login";
			}
		}

		bool Authenticate (string name, string password)
		{
			//
			// Fetch the connection string from Web.config and decrypt it.
			// *** "server=localhost;database=login;uid=webuser;pwd=webuser" ***
			//
			DataProtector dp = new DataProtector (DataProtector.Store.USE_MACHINE_STORE);
			string val = ConfigurationSettings.AppSettings["ConnectionString"];
			byte[] data = Convert.FromBase64String (val);
			string connect = Encoding.ASCII.GetString (dp.Decrypt (data, null));

			//
			// Validate the password that the user entered.
			//
			SqlConnection connection = new SqlConnection (connect);

			try 
			{
				connection.Open ();
				SqlCommand command = new SqlCommand ("proc_GetPasswordHash", connection);
				command.CommandType = CommandType.StoredProcedure;
				command.Parameters.Add ("@UserName", SqlDbType.VarChar).Value = name;
				object result = command.ExecuteScalar ();
				
				if (result != null) 
				{
					string hash = (string) result;
					return ValidatePassword (password, hash);
				}

				return false;
			}
			finally 
			{
				connection.Close ();
			}
		}

		bool ValidatePassword (string password, string saltedHash)
		{
			// Extract hash and salt string
			string saltString = saltedHash.Substring (saltedHash.Length - 24);
			string hash1 = saltedHash.Substring (0, saltedHash.Length - 24);

			// Append the salt string to the password
			string saltedPassword = password + saltString;

			// Hash the salted password
			string hash2 = FormsAuthentication.HashPasswordForStoringInConfigFile
				(saltedPassword, "SHA1");

			// Compare the hashes
			return (hash1.CompareTo (hash2) == 0);
		}

		//
		// Use this method to generate salted password hashes.
		//
		string CreateSaltedPasswordHash (string password)
		{
			// Generate random salt string
			RNGCryptoServiceProvider csp = new RNGCryptoServiceProvider ();
			byte[] saltBytes = new byte[16];
			csp.GetNonZeroBytes (saltBytes);
			string saltString = Convert.ToBase64String (saltBytes);

			// Append the salt string to the password
			string saltedPassword = password + saltString;

			// Hash the salted password
			string hash = FormsAuthentication.HashPasswordForStoringInConfigFile
				(saltedPassword, "SHA1");

			// Append the salt to the hash
			string saltedHash = hash + saltString;
			return saltedHash;
		}
	}
}
