using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Inject
{
	/// <summary>
	/// Summary description for BadQuotes.
	/// </summary>
	public class GoodQuotes : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Quote;
		protected System.Web.UI.WebControls.Label Author;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			string id = Request["ID"];

			if (id != null && id != String.Empty) {
				//
				// Make sure ID is a number and that it's in range.
				//
				int num = -1;

				try {
					num = Convert.ToInt32 (id);
				}
				catch (FormatException) {
					return;
				}
				
				if (num < 1 || num > 10)
					return;

				//
				// Use ID in a database query.
				//
				SqlConnection connection = new SqlConnection ("server=localhost;database=quotes;uid=webuser;pwd=webuser");

				try 
				{
					connection.Open ();
					SqlCommand command = new SqlCommand ("proc_GetQuote", connection);
					command.CommandType = CommandType.StoredProcedure;
					command.Parameters.Add ("@ID", SqlDbType.Int).Value = num;
					SqlDataReader reader = command.ExecuteReader ();

					if (reader.Read ()) {
						Quote.Text = reader["Quotation"].ToString ();
						Author.Text = reader["Author"].ToString ();
					}
				}
				finally 
				{
					connection.Close ();
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
