CREATE DATABASE Login
GO

USE Login
GO

CREATE TABLE BadUsers
(
    UserName    varchar(32)    NOT NULL, 
    Password    varchar(32)    NOT NULL
)
GO

INSERT INTO BadUsers (UserName, Password) VALUES ('Jeff',  'imbatman')
INSERT INTO BadUsers (UserName, Password) VALUES ('John',  'redrover')
INSERT INTO BadUsers (UserName, Password) VALUES ('Bob',   'mxyzptlk')
INSERT INTO BadUsers (UserName, Password) VALUES ('Alice', 'nomalice')
GO

CREATE TABLE GoodUsers
(
    UserName        varchar(32)     NOT NULL, 
    PasswordHash    varchar(512)    NOT NULL
)
GO

INSERT INTO GoodUsers (UserName, PasswordHash) VALUES ('Jeff',  '20CE3D2D54935D7CD5040ED736E644867175D7E5M+YUWNzxYtLLXeus/9fkzw==')
INSERT INTO GoodUsers (UserName, PasswordHash) VALUES ('John',  '66AAF6C17D450F9574D7548836384EFC40CE3F0CBs1VJ4YiGsN6qYGSEW+VeA==')
INSERT INTO GoodUsers (UserName, PasswordHash) VALUES ('Bob',   'EC12758AE778C54155006F2A75B69F7AC39D352AW7SU4TKBo7PVfr077OdNpw==')
INSERT INTO GoodUsers (UserName, PasswordHash) VALUES ('Alice', 'A4F42098CC7B052B36800B9D675BCAC9440AB3A8df38WyHT2R8BVpiFmS9Mdw==')
GO

CREATE PROCEDURE proc_GetPasswordHash @UserName VarChar (32) AS
SELECT PasswordHash FROM GoodUsers WHERE UserName = @UserName
GO

EXEC sp_addlogin 'WebUser', 'webuser', 'Login'
EXEC sp_grantdbaccess 'WebUser'
GRANT EXECUTE ON proc_GetPasswordHash TO WebUser
GO