CREATE DATABASE Quotes
GO

USE Quotes
GO

CREATE TABLE Quotations
(
    Quotation   varchar(256)    NOT NULL, 
    Author      varchar(64)     NOT NULL,
    ID          smallint        NOT NULL
)
GO

INSERT INTO Quotations (Quotation, Author, ID) VALUES ('Give me chastity and continence, but not yet.', 'Saint Augustine', 1)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('The use of COBOL cripples the mind; its teaching should therefore be regarded as a criminal offense.', 'Edsger Dijkstra', 2)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('C makes it easy to shoot yourself in the foot; C++ makes it harder, but when you do, it blows away your whole leg.', 'Bjarne Stroustrup', 3)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('A programmer is a device for turning coffee into code.', 'Jeff Prosise (with an assist from Paul Erdos)', 4)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('I have not failed. I''ve just found 10,000 ways that won''t work.', 'Thomas Edison', 5)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('Blessed is the man who, having nothing to say, abstains from giving wordy evidence of the fact.', 'George Eliot', 6)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('I think there is a world market for maybe five computers.', 'Thomas Watson', 7)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('Computers in the future may weigh no more than 1.5 tons.', 'Popular Mechanics', 8)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('I have traveled the length and breadth of this country and talked with the best people, and I can assure you that data processing is a fad that won''t last out the year.', 'Prentice-Hall business books editor', 9)
INSERT INTO Quotations (Quotation, Author, ID) VALUES ('640K ought to be enough for anybody.', 'William Gates III', 10)
GO

CREATE PROCEDURE proc_GetQuote @ID Int AS
SELECT Quotation, Author FROM Quotations WHERE ID=@ID
GO

EXEC sp_addlogin 'WebUser', 'webuser', 'Login'
EXEC sp_grantdbaccess 'WebUser'
GRANT EXECUTE ON proc_GetQuote TO WebUser
GO