CREATE DATABASE Forums
GO

USE Forums
GO

CREATE TABLE Messages
(
    Title    varchar(64)      NOT NULL, 
    Body     varchar(512)     NOT NULL,
    Time     smalldatetime    NOT NULL
)
GO

INSERT INTO Messages (Title, Body, Time) VALUES (
  'Lost Bits',
  'A coworker told me that bits are streaming out the back of my computer and that I need to put a bucket back there to catch them. What kind of bucket should I use?',
  '2003-06-18 14:35:29'
)
INSERT INTO Messages (Title, Body, Time) VALUES (
  'RE: Lost Bits',
  'A plastic bucket is best; a metal one tends to ring when the bits hit it.',
  '2003-06-18 14:42:00'
)
GO

CREATE PROCEDURE proc_GetMessages AS
SELECT * FROM Messages ORDER BY Time
GO

CREATE PROCEDURE proc_PutMessage @Title VarChar(64), @Body VarChar(512), @Time SmallDateTime AS
INSERT INTO Messages (Title, Body, Time) VALUES (@Title, @Body, @Time)
GO

EXEC sp_addlogin 'WebUser', 'webuser', 'Forums'
EXEC sp_grantdbaccess 'WebUser'
GRANT EXECUTE ON proc_GetMessages TO WebUser
GRANT EXECUTE ON proc_PutMessage TO WebUser
GO